SystemOrganization addCategory: #'Magritte-JQuery-Seaside-Components'!

MATextInputComponent subclass: #MAJQDateInputComponent
	instanceVariableNames: 'dateSelector id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQuery-Seaside-Components'!

!MAJQDateInputComponent methodsFor: 'hooks' stamp: 'NickAger 3/3/2010 16:49'!
children
	^ Array with: dateSelector
	! !

!MAJQDateInputComponent methodsFor: 'rendering' stamp: 'NickAger 3/4/2010 11:29'!
datePickerOnSelectJavascript
	"Subleties within this code:
	* the date passed in the first argument of onSelect is a string in the form MM/DD/YYYY, regardless of whether the locale of my browser was set to en-us or en-gb. The Date object parses the argument string as expected, however this has not been tested using other locales.
	* The html select tags generated by WADateSelector do not have DOM ids. To locate the select tags this code relies on the first select being the month, the second the day and the third the year. Changes in the ordering of the select tags within WADateSelector will require a change to the code below.
	* Setting the day and month selectors is straightforward as the value relates directly to the day or month. However for the year the code iterates over the year options, looking for text which matches the selected date as the year options values don't relate to the year. 
	"
^ 	'
var selectedDate = new Date(arguments[0]);
var dateSelectors = $(''#dateSelector'').children();

$(dateSelectors[0]).val(selectedDate.getMonth()+1);
$(dateSelectors[1]).val(selectedDate.getDate());

var yearSelector= dateSelectors[2];
var year = selectedDate.getFullYear();
for (var i = 0, length = yearSelector.options.length; i < length; ++i) {
	if (yearSelector.options[i].text == year) {
		yearSelector.selectedIndex = i;
		break;
	}
}
'
! !

!MAJQDateInputComponent methodsFor: 'initialization' stamp: 'NickAger 3/4/2010 15:43'!
initialize
	super initialize.
	
	dateSelector := WADateSelector new! !

!MAJQDateInputComponent methodsFor: 'rendering' stamp: 'NickAger 2/16/2012 15:35'!
renderInputOn: html
	dateSelector date: self value.
	
	html span id: #dateSelector; with: [
		html render: dateSelector.
		html space ].
	
	html hiddenInput
		value: self value;
		callback: [self value: dateSelector date];
		script: (html jQuery this datepicker
			showOn: 'button';
			buttonImage: JQDevelopmentLibrary / #calendarGif;
			buttonImageOnly: true;
			defaultDate: self value;
			onSelect: self datePickerOnSelectJavascript)
! !

!JQDevelopmentLibrary methodsFor: '*magritte-jquery-seaside-components' stamp: ''!
calendarGif
	^ #(71 73 70 56 57 97 16 0 15 0 244 0 0 140 170 239 57 113 222 90 138 231 49 105 206 115 158 239 254 246 245 251 225 223 253 242 241 237 101 94 221 99 92 238 109 101 239 115 108 188 94 89 240 122 115 169 91 87 241 131 125 242 136 130 242 141 135 243 152 146 244 155 150 244 162 157 245 171 167 119 83 81 246 176 171 247 181 177 253 235 234 255 252 252 255 253 253 255 255 255 255 255 255 0 0 0 0 0 0 33 249 4 1 0 0 29 0 44 0 0 0 0 16 0 15 0 0 5 138 224 101 137 164 53 141 232 165 60 156 210 190 110 194 49 179 113 93 85 69 81 82 20 61 192 197 2 129 184 100 142 200 91 110 73 41 42 117 146 168 47 56 172 112 56 146 107 22 187 217 72 10 5 135 149 3 185 150 201 93 72 193 32 174 64 26 146 119 28 64 16 4 226 98 173 126 67 208 104 2 25 23 14 19 102 102 93 2 26 7 3 25 24 131 110 112 114 16 1 1 3 3 120 132 88 28 94 96 18 71 18 6 141 152 16 105 96 16 71 16 160 142 18 13 21 171 173 172 171 23 16 131 14 181 182 183 184 33 0 59) asByteArray! !
